Issues autocomplete may not find issues with a subject longer than 60 characters
Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 4.2.0   

Resolution: Fixed Affected version:  

Description

Reproduction procedure:

Create a issue with subject "-------------------The quick brown fox jumps over the lazy dog."(Subject longer than 60 characters)

Check if the created issue is complete (In the textarea of other issues).

Write "#brown" => autocompleted

Write "#dog" => not autocompleted

"https://----------/issues/auto_complete?q=dog" will return the result as shown below.

[{"id":1,"label":"Bug #1: -------------------The quick brown fox jumps over the laz...","value":1

}]

 Although the created issue is returned, the label is omitted on the way and the character string such as dog is not included.

(http://www.redmine.org/projects/redmine/repository/entry/trunk/app/controllers/auto_completes_controller.rb#L58)

I think that tribute.js has removed it from the candidate because the search keyword is not included in label.

Related issues:

Blocked by Redmine - Feature #31887: Update jQuery UI to 1.12.1 Closed

Associated revisions

Revision 19771 - 2020-05-13 02:46 - Go MAEDA

Fix that issues autocomplete may not find issues with a subject longer than 60 characters (#12250).

Contributed by Mizuki ISHIKAWA.

Revision 19772 - 2020-05-13 09:21 - Go MAEDA

Revert r19771 due to the incorrect issue number in the commit message.

Revision 19773 - 2020-05-13 09:22 - Go MAEDA

Fix that issues autocomplete may not find issues with a subject longer than 60 characters (#32125).

Contributed by Mizuki ISHIKAWA.

Revision 19775 - 2020-05-14 15:40 - Go MAEDA

Reverts r19773 (#32125).

The purpose of reverting is to revert r19769 on which r19773 depends.

Revision 19784 - 2020-05-18 16:13 - Go MAEDA

Fix that issues autocomplete may not find issues with a subject longer than 60 characters (#32125).

Contributed by Mizuki ISHIKAWA.

History

#1 - 2019-09-24 07:15 - Mizuki ISHIKAWA

Do I need to return a subject that is shortened to 60 characters?
If not, you can fix the problem by making the changes below.

diff --git a/app/controllers/auto_completes_controller.rb b/app/controllers/auto_completes_controller.rb

index 336885349..bbe5b13ed 100644

--- a/app/controllers/auto_completes_controller.rb

+++ b/app/controllers/auto_completes_controller.rb

@@ -55,7 +55,7 @@ class AutoCompletesController < ApplicationController

   def format_issues_json(issues)

     issues.map {|issue| {

       'id' => issue.id,

-      'label' => "#{issue.tracker} ##{issue.id}: #{issue.subject.to_s.truncate(60)}",

+      'label' => "#{issue.tracker} ##{issue.id}: #{issue.subject}",

       'value' => issue.id

       }

     }

#2 - 2019-10-06 10:47 - Go MAEDA

I don't think the truncation is necessary. Even if the truncation is necessary, 60 characters long is too short. It can be raised to 255, the maximum

length of string in ActiveRecord.

#3 - 2019-10-15 04:10 - Go MAEDA

- Target version set to Candidate for next major release

#4 - 2019-11-03 11:55 - Go MAEDA

After applying the patch, the autocomplete dropdown gets too wide when it includes long subjects. I think we should somehow limit the width of the

dropdown when removing truncate(60).

truncate(60) was added in r10068, when Prototype and script.aculo.us were replaced with JQuery. Maybe the replacement caused the issue I

described above and truncate(60) was added as a workaround for that.

#5 - 2019-11-03 12:00 - Go MAEDA

- File too-wide-dropdown@2x.png added

Go MAEDA wrote:

After applying the patch, the autocomplete dropdown gets too wide when it includes long subjects.

 Screenshot of that.

 

#6 - 2019-11-20 05:13 - Mizuki ISHIKAWA

- File fix-32125.patch added

- File example-1.png added

- File example-2.png added

Go MAEDA wrote:

After applying the patch, the autocomplete dropdown gets too wide when it includes long subjects. I think we should somehow limit the width of

the dropdown when removing truncate(60).

 I attached a patch that omits the subject line if the width exceeds 400px.

 example-1.png 
example-2.png 

#7 - 2020-05-03 08:58 - Go MAEDA
- Target version changed from Candidate for next major release to 4.2.0

Setting the target version to 4.2.0.

#8 - 2020-05-11 06:23 - Go MAEDA

- File fix-32125-v2.patch added

I have updated the patch to cleanly applicable after r19769. And I slightly modified as follows:

Instead of removing truncate(60) from source:tags/4.1.1/app/controllers/auto_completes_controller.rb#L59, changed to truncate(255). Although

the maximum length of a subject is limited to 255 by database schema, the change guarantees that the length of a subject in JSON data will

never exceed 255.

Since it is ensured that the length of the Subject does not exceed 255, we can say that UI issues due to abnormally long subjects unlikely to

occur. So, I simplify the change against CSS. I have removed white-space, text-overflow, and overflow properties from the previous patch.

#9 - 2020-05-11 07:30 - Go MAEDA

- Subject changed from Long subject issue may not autocomplete with #keyword to Issues autocomplete may not find issues with a subject longer

than 60 characters

#10 - 2020-05-13 02:48 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix. Thank you.

#11 - 2020-05-14 08:27 - Go MAEDA

- Blocked by Feature #31887: Update jQuery UI to 1.12.1 added

#12 - 2020-05-14 15:46 - Go MAEDA

- Status changed from Closed to Reopened

- Resolution deleted (Fixed)

Reverted r19773.

The revert was necessary to revert r19769 because r19773 depends on the commit.

#13 - 2020-05-18 16:14 - Go MAEDA

- Status changed from Reopened to Closed

- Resolution set to Fixed

Go MAEDA wrote:

Reverted r19773.

The revert was necessary to revert r19769 because r19773 depends on the commit.

 Committed the patch again.

Files

too-wide-dropdown@2x.png 18.2 KB 2019-11-03 Go MAEDA

fix-32125.patch 1.72 KB 2019-11-20 Mizuki ISHIKAWA

example-1.png 27.9 KB 2019-11-20 Mizuki ISHIKAWA

example-2.png 80.1 KB 2019-11-20 Mizuki ISHIKAWA

fix-32125-v2.patch 1.08 KB 2020-05-11 Go MAEDA
